(* =========================================================================  
   Map Slide Functions onto Astrobe Library functions

   Target: Hardware-independent
  
   (c) 2009-2012 CFB Software   
   http://www.astrobe.com  
   
   ========================================================================= *)

MODULE Graph;

IMPORT LCD := LCDEpson, Graphics;

CONST
  size = 10;
  whiteOnBlack* = TRUE;
  MaxX* = LCD.MaxX;
  MaxY* = LCD.MaxY;

VAR
  highX*, highY*: INTEGER;
  colourMap: ARRAY 9 OF INTEGER;
  lastFromX, lastFromY, lastToX, lastToY, lastColour: INTEGER;

PROCEDURE Init*;
VAR
  i: INTEGER;
BEGIN
  (* AutoCad colours are numbered differently to adapter colours. *)
  (* The colourMap array is used for conversion.                  *)
  colourMap[1] := LCD.Red;
  colourMap[2] := LCD.Yellow;
  colourMap[3] := LCD.Green;
  colourMap[4] := LCD.Cyan;
  colourMap[5] := LCD.Blue;
  colourMap[6] := LCD.Magenta;
  IF whiteOnBlack THEN
  	colourMap[7] := LCD.White;
  	colourMap[8] := LCD.Black
  ELSE
  	colourMap[7] := LCD.Black;
  	colourMap[8] := LCD.White
  END;

(*  FOR i := 0 TO LEN(colourMap) - 1 DO colourMap[i] := LCD.Black END; *)
  highX := LCD.MaxX;
  highY := LCD.MaxY;
  lastFromX := -1;
  lastFromY := -1;
  lastToX := -1;
  lastToY := -1;
  lastColour := -1;
  LCD.Init;
  Graphics.Init(LCD.MaxX, LCD.MaxY, LCD.DrawDot)
END Init;

PROCEDURE Line*(fromX, fromY, toX, toY: INTEGER; colour: INTEGER);
BEGIN
  IF (lastFromX # fromX) OR (lastFromY # fromY) OR (lastToX # toX) OR (lastToY # toY) OR (lastColour # colour) THEN 
    Graphics.Line(colourMap[colour], fromX, fromY, toX, toY);
    lastFromX := fromX; 
    lastFromY := fromY; 
    lastToX := toX; 
    lastToY := toY; 
    lastColour := colour
  END 
END Line;

END Graph.
